/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package pouringwater_jf;

import java.util.Arrays;

/**
 *
 * @author yare
 */
public class State {

    public byte[] buckets;
    int steps = 0;
    State prev = null;
    public Instance instance;

    public State(byte[] buckets, Instance instance) {
        this.buckets = buckets;
        this.instance = instance;
    }

    State() {
//        throw new UnsupportedOperationException("Not yet implemented");
    }

    @Override
    protected Object clone() {
        State newState = new State();
        newState.steps = this.steps;
        newState.prev = this.prev;
        newState.instance = this.instance;

        newState.buckets = new byte[buckets.length];
        System.arraycopy(this.buckets, 0, newState.buckets, 0, buckets.length);
        return newState;
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 83 * hash + Arrays.hashCode(this.buckets);
        return hash;
    }

    public int hash() {
        return Arrays.hashCode(this.buckets);
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final State other = (State) obj;
        if (!Arrays.equals(this.buckets, other.buckets)) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
//        String s = "Steps=" + steps + ", buckets=";
        String s = Arrays.toString(buckets);
        return s;
    }

    public State fill(int i, byte capacity) {
        State newState = null;
        if (this.buckets[i] < capacity) {
            newState = (State) this.clone();
            newState.buckets[i] = capacity;
            newState.prev = this;
            newState.steps++;
        }
        return newState;
    }

    public State empty(int i) {
        State newState = null;
        if (this.buckets[i] > 0) {
            newState = (State) this.clone();
            newState.buckets[i] = 0;
            newState.prev = this;
            newState.steps++;
        }
        return newState;
    }

    public State pour(int to, byte capacity, int from) {
        State newState = null;
        if (this.buckets[from] > 0 && this.buckets[to] < capacity) {
            newState = (State) this.clone();
            // pour only [cap - to]
            if (this.buckets[to] + this.buckets[from] > capacity) {
                newState.buckets[to] = capacity;
                newState.buckets[from] = (byte) (this.buckets[to] + this.buckets[from] - capacity);
            // pour all 
            } else {
                newState.buckets[to] += this.buckets[from];
                newState.buckets[from] = 0;
            }
            newState.prev = this;
            newState.steps++;
        }
        return newState;
    }
    
        public State pour2(int from, byte[] capacity, int to) {
        State newState = null;
        if (this.buckets[from] > 0 && this.buckets[to] < capacity[to]) {
            newState = (State) this.clone();
            // pour only [cap - to]
            if (this.buckets[to] + this.buckets[from] > capacity[to]) {
                newState.buckets[to] = capacity[to];
                newState.buckets[from] = (byte) (this.buckets[to] + this.buckets[from] - capacity[to]);
            // pour all 
            } else {
                newState.buckets[to] += this.buckets[from];
                newState.buckets[from] = 0;
            }
            newState.prev = this;
            newState.steps++;
        }
        return newState;
    }

    public String printPath() {
        String str = this.toString();
        State state = this.prev;
        while (state != null) {
            str = state + " " + str;
            state = state.prev;
        }
        return "Path (" + (steps) + "): " + str;
    }

}
